<template>
  <div id="CreateOrEditMovementShapesForm">
    <v-form ref="formCreateUpdateFaqs">
      <v-container>
        <!-- Name -->
        <v-row>
          <v-col cols="12">
            <!--Default-->
            <template>
              <label
                class="body-1-sistem family-openSans-regular cursor-pointer"
                for="name"
              >
                {{ $t("global.name") }} -----

                <span class="family-lato-black">
                  ({{ this.$i18n.defaultLocale }})
                </span>
              </label>

              <v-text-field
                id="name"
                outlined
                type="text"
                v-model="form.nome"
                :rules="[
                  verifyMaxLengthMixin(form.nome, 255),
                  verifyDataRequiredMixin(form.nome),
                ]"
                hide-details="auto"
                class="mb-4"
              ></v-text-field>
            </template>

            <!--Translate-->
            <div
              v-for="(language, index) in form.translate"
              :key="index + 'name'"
            >
              <label
                class="body-1-sistem family-openSans-regular cursor-pointer"
                :for="'name' + index"
              >
                {{ $t("global.name") }}

                <span class="family-lato-black"> ({{ index }}) </span>
              </label>

              <v-text-field
                :id="'name' + index"
                outlined
                type="text"
                v-model="form.translate[index].nome"
                :rules="[verifyMaxLengthMixin(form.translate[index].nome, 255)]"
                hide-details="auto"
              ></v-text-field>
            </div>
          </v-col>
        </v-row>

        <!--Status-->
        <v-row>
          <v-col cols="12">
            <v-checkbox
              color="success"
              v-model="form.status"
              :label="
                form.status
                  ? $t('global.status.title') +
                    ': ' +
                    $t('global.status.aproved')
                  : $t('global.status.title') +
                    ': ' +
                    $t('global.status.pending')
              "
            ></v-checkbox>
          </v-col>
        </v-row>

        <!--Author and Responsible-->
        <v-row>
          <v-col cols="12" sm="6" md="5" lg="3" xl="2">
            <SummaryAuthorCard />
          </v-col>
          <v-col cols="12" sm="6" md="5" lg="3" xl="2">
            <SummaryResponsibleCard />
          </v-col>
        </v-row>

        <!--Buttons-->
        <v-row>
          <v-col cols="12">
            <div class="text-center">
              <!--Back-->
              <v-btn
                @click="localePath($router.go(-1))"
                rounded
                color="info"
                depressed
                outlined
                class="mb-2"
              >
                <span class="family-openSans-bold">
                  {{ $t("buttons.back") }}
                </span>
              </v-btn>

              <!--Delete-->
              <v-btn
                rounded
                color="error"
                depressed
                outlined
                @click.stop.prevent="dialogDelete = true"
                class="mb-2"
              >
                <span class="family-openSans-bold">
                  {{ $t("buttons.delete") }}
                </span>
              </v-btn>

              <!--Submit-->
              <v-btn
                depressed
                rounded
                color="warning"
                @click.stop.prevent="submitForm()"
                class="family-openSans-bold mb-2"
                :loading="loadingForm"
              >
                <span class="family-openSans-bold">
                  {{
                    currentValue
                      ? $t("global_buttons.btn_edit_faq")
                      : $t("buttons.create")
                  }}
                </span>
              </v-btn>
            </div>
          </v-col>
        </v-row>
      </v-container>
    </v-form>

    <v-dialog v-if="dialogDelete" max-width="800px" v-model="dialogDelete">
      <v-card>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn icon color="system_grey_3" @click="dialogDelete = false">
            <v-icon>mdi-close</v-icon>
          </v-btn>
        </v-card-actions>
        <v-card-text class="px-0"> DeleteFaqModal </v-card-text>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import ValidationFormsMixin from "@/mixins/Forms/ValidationFormsMixin.vue";
import TranslateMixin from "@/mixins/Global/TranslateMixin.vue";
import SummaryResponsibleCard from "@/components/Cards/Users/SummaryResponsibleCard.vue";
import SummaryAuthorCard from "@/components/Cards/Users/SummaryAuthorCard.vue";

export default {
  mixins: [ValidationFormsMixin, TranslateMixin],
  components: { SummaryResponsibleCard, SummaryAuthorCard },

  props: ["currentValue"],

  data() {
    return {
      loadingForm: false,

      form: {
        nome: "",
        status: false,
        translate: null,
      },

      form_data_translate: {
        name: "",
      },

      dialogDelete: false,
    };
  },

  mounted() {
    this.addTranslateInFormMixin();

    if (this.currentValue) {
      this.form = Object.assign({}, this.currentValue);
    }
  },

  methods: {
    submitForm() {
      if (this.currentValue) {
        this.edit();
      } else {
        this.post();
      }
    },

    edit() {
      this.loadingForm = true;
      this.$axios
        .put(`faqs/${this.currentValue.id}`, this.form)
        .then(() => {
          this.$toast.success(this.$t("global_message_alerts.success_edit"));
          this.$router.push(
            this.localePath("/control-panel/faqs", this.$i18n.locale)
          );
        })
        .catch(() => {
          this.$toast.error(this.$t("global_message_alerts.error_edit"));
        })
        .finally(() => {
          this.loadingForm = false;
        });
    },

    post() {
      console.log("form", this.form);
      //this.loadingForm = true;
      //this.$axios
      //.post(`faqs`, this.form)
      //.then(() => {
      // this.$toast.success(this.$t("global_message_alerts.success_create"));
      // this.$router.push(
      //    this.localePath("/control-panel/faqs", this.$i18n.locale)
      // );
      //  })
      //  .catch(() => {
      //    this.$toast.error(this.$t("global_message_alerts.error_create"));
      //  })
      //  .finally(() => {
      //    this.loadingForm = false;
      //  });
    },
  },
};
</script>
